---
title: FileReader.readAsBinaryString()
slug: Web/API/FileReader/readAsBinaryString
tags:
  - API
  - File API
  - Files
  - Method
  - Reference
---
<div>{{APIRef("File API")}}</div>

<p>The <code>readAsBinaryString</code> method is used to start reading the contents of the specified {{domxref("Blob")}} or {{domxref("File")}}. When the read operation is finished, the {{domxref("FileReader.readyState","readyState")}} becomes <code>DONE</code>, and the {{event("loadend")}} is triggered. At that time, the {{domxref("FileReader.result","result")}} attribute contains the raw binary data from the file.</p>

<p>Note that this method was once removed from the File API specification, but re-introduced for backward compatibility.<br>
 Using {{domxref("FileReader.readAsArrayBuffer()")}} is recommended.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>instanceOfFileReader</em>.readAsBinaryString(blob);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>blob</code></dt>
 <dd>The {{domxref("Blob")}} or {{domxref("File")}} from which to read.</dd>
</dl>

<h2 id="Example">Example</h2>

<pre class="brush: js">var canvas = document.createElement('canvas');
var height = 200;
var width  = 200;

canvas.width  = width;
canvas.height = height;

var ctx = canvas.getContext('2d');

ctx.strokeStyle = '#090';
ctx.beginPath();
ctx.arc(width/2, height/2, width/2 - width/10, 0, Math.PI*2);
ctx.stroke();

canvas.toBlob(function (blob) {
  var reader = new FileReader();

  reader.onload = function () {
    console.log(reader.result);
  }

  reader.readAsBinaryString(blob);
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('File API','#readAsBinaryString','readAsBinaryString')}}</td>
   <td>{{Spec2('File API')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.FileReader.readAsBinaryString")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("FileReader")}}</li>
</ul>
